package com.bonus.canteen.core.menu.mapper;

import java.util.List;

import com.bonus.canteen.core.menu.domain.MapBean;
import com.bonus.canteen.core.menu.domain.MenuDishes;
import com.bonus.canteen.core.menu.domain.MenuDishesRelation;
import com.bonus.canteen.core.menu.dto.MenuDishesAddMaterialDTO;
import com.bonus.canteen.core.menu.dto.MenuDishesDTO;
import com.bonus.canteen.core.utils.NutritionEntity;

/**
 * 菜品信息Mapper接口
 *
 * @author xsheng
 * @date 2025-04-03
 */
public interface MenuDishesMapper {
    /**
     * 查询菜品信息
     *
     * @param id 菜品信息主键
     * @return 菜品信息
     */
    public MenuDishes selectMenuDishesById(Long id);

    /**
     * 查询菜品信息列表
     *
     * @param menuDishes 菜品信息
     * @return 菜品信息集合
     */
    public List<MenuDishes> selectMenuDishesList(MenuDishes menuDishes);

    /**
     * 新增菜品信息
     *
     * @param menuDishes 菜品信息
     * @return 结果
     */
    public int insertMenuDishes(MenuDishes menuDishes);

    /**
     * 修改菜品信息
     *
     * @param menuDishes 菜品信息
     * @return 结果
     */
    public int updateMenuDishes(MenuDishes menuDishes);

    /**
     * 删除菜品信息
     *
     * @param id 菜品信息主键
     * @return 结果
     */
    public int deleteMenuDishesById(Long id);

    /**
     * 批量删除菜品信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteMenuDishesByIds(Long[] ids);

    List<MapBean> getDishesType(MapBean mapBean);

    MenuDishes getOne(MenuDishesDTO menuDishesDTO);

    int addMenuDishesBase(MenuDishesDTO menuDishesDTO);

    int addMenuDishes(MenuDishesDTO menuDishesDTO);

    int adddishesLabel(MenuDishesRelation menuDishesRelation);
    int adddishesTaste(MenuDishesRelation menuDishesRelation);
    int adddishesSeason(MenuDishesRelation menuDishesRelation);
    int adddishesSuit(MenuDishesRelation menuDishesRelation);
    int adddishesMeal(MenuDishesRelation menuDishesRelation);

    NutritionEntity getNutritionEntity(MenuDishesAddMaterialDTO dto);

    int addFinalNutrition(NutritionEntity nutritionEntity);
}
